package github.nisrulz.projectrecyclerviewhelper;

import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;
import github.nisrulz.recyclerviewhelper.RVHAdapter;
import github.nisrulz.recyclerviewhelper.RVHViewHolder;
import java.util.Collections;
import java.util.List;

public class MyAdapter extends RecyclerView.Adapter<MyAdapter.ItemViewHolder>
    implements RVHAdapter {

  List<String> dataList;

  public MyAdapter(List<String> dataList) {
    this.dataList = dataList;
  }

  @Override public ItemViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {

    View view =
        LayoutInflater.from(parent.getContext()).inflate(R.layout.rv_list_item, parent, false);

    return new ItemViewHolder(view);
  }

  @Override public void onBindViewHolder(ItemViewHolder holder, int position) {
    holder.txt.setText(dataList.get(position));
  }

  @Override public int getItemCount() {
    return dataList.size();
  }

  @Override public boolean onItemMove(int fromPosition, int toPosition) {
    swap(fromPosition, toPosition);
    return false;
  }

  @Override public void onItemDismiss(int position, int direction) {
    remove(position);
  }

  public class ItemViewHolder extends RecyclerView.ViewHolder implements RVHViewHolder {
    TextView txt;

    public ItemViewHolder(View itemView) {
      super(itemView);
      txt = (TextView) itemView.findViewById(R.id.txt);
    }

    @Override public void onItemSelected(int actionstate) {
      System.out.println("Item is selected");
    }

    @Override public void onItemClear() {
      System.out.println("Item is unselected");
    }
  }

  private void remove(int position) {
    dataList.remove(position);
    notifyItemRemoved(position);
  }

  private void swap(int firstPosition, int secondPosition) {
    Collections.swap(dataList, firstPosition, secondPosition);
    notifyItemMoved(firstPosition, secondPosition);
  }
}
